"use strict";
{
    const C3 = self.C3;

    C3.Plugins.EMI_INDO_IDFA_AAID.Instance = class IDFA_AAIDInstance extends C3.SDKInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);


            if (properties)
            {}


            if (typeof cordova == 'undefined')
            {
                return;
            }
            else
            {};

            this.EMI_INDO = C3.Plugins.EMI_INDO_IDFA_AAID.Cnds;

            this.res = "";

            const self = this;

            const getInfo = async() => {
                const idfaPlugin = cordova.plugins.idfa;

                await idfaPlugin.getInfo()
                    .then(info => {
                    if (!info.trackingLimited)
                    {
                        return info.idfa || info.aaid;
                    }
                    else if (info.trackingPermission === idfaPlugin.TRACKING_PERMISSION_NOT_DETERMINED)
                    {
                        self.Trigger(self.EMI_INDO.Tracking_Not)
                        return idfaPlugin.requestPermission().then(result => {
                            if (result === idfaPlugin.TRACKING_PERMISSION_NOT_DETERMINED)
                            {
                                self.Trigger(self.EMI_INDO.Permission_Not_Determined)
                            }
                            else if (result === idfaPlugin.TRACKING_PERMISSION_RESTRICTED)
                            {
                                self.Trigger(self.EMI_INDO.Permission_Restricted)

                            }
                            else if (result === idfaPlugin.TRACKING_PERMISSION_DENIED)
                            {
                                self.Trigger(self.EMI_INDO.Permission_Denied)

                            }
                            else if (result === idfaPlugin.TRACKING_PERMISSION_AUTHORIZED)
                            {
                                self.Trigger(self.EMI_INDO.Permission_Authorized)

                                return idfaPlugin.getInfo().then(info => {
                                    return info.idfa || info.aaid;
                                });
                            }
                        });
                    }
                })
                    .then(idfaOrAaid => {
                    if (idfaOrAaid)
                    {
                        self.res = (idfaOrAaid)
                        self.Trigger(self.EMI_INDO.Idfaoraaid)
                    }
                });

            }

            this.getInfo = getInfo;



        }

        Release()
        {
            super.Release();
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }

        GetDebuggerProperties()
        {
            return [
            {
                title: "IDFA_AAID",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }

        // timeline support
        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}